// BKDL.cpp:      .
//

#include "stdafx.h"
#include "BKDL.h"
#include <io.h>
#include <list>
#include "getopt.h"

using namespace std;

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


//   
CWinApp theApp;

BOOL bRecursive = FALSE;	//,      
BOOL bCSV = FALSE;			//    .
CString strLstFile = _T("Files.lst");
CString strTxtFile = _T("Files.txt");
CString strStartPath;	// ,    

#define KNOWN_EXTS 3
CString	pstrExts[KNOWN_EXTS] = {
	_T(".img"),
	_T(".bkd"),
	_T(".dsk")
};

CMyListCtrl myListCtrl;
int nFilesTotal = -1; //  -1     ,     ,  -  .

/*
 .
1. -r -    ,    -    
2. -t -   files.txt -  ,    -   
3. -l -   files.lst -  ,    -   
4. -c -    CSV   ,      

  ,    -  

*/
int _tmain(int argc, TCHAR* argv[], TCHAR* envp[])
{
	int nRetCode = 0;
	_tsetlocale(LC_ALL,_T("Russian"));

	HMODULE hModule = ::GetModuleHandle(NULL);

	if (hModule != NULL)
	{
		//  MFC,         
		if (!AfxWinInit(hModule, NULL, ::GetCommandLine(), 0))
		{
			// TODO:      
			_tprintf(_T(" :    MFC\n"));
			nRetCode = 1;
		}
		else
		{
			static struct option long_options[] =
			{
				{_T("help"),		ARG_NONE, 0, _T('h')},
				{_T("recursive"),	ARG_NONE, 0, _T('r')},
				{_T("csv"),			ARG_NONE, 0, _T('c')},
				{_T("list"),		ARG_REQ,  0, _T('l')},
				{_T("text"),		ARG_REQ,  0, _T('t')},
				{ ARG_NULL , ARG_NULL , ARG_NULL , ARG_NULL }
			};
			int option_index = 0;
			int c;
			while ((c = getopt_long(argc, argv, _T("hrcl:t:"), long_options, &option_index)) != -1)
			{
				// Handle options
				switch (c)
				{
				case _T('r'):
					bRecursive = TRUE;
					break;
				case _T('c'):
					bCSV = TRUE;
					strLstFile = _T("Files.csv");
					break;
				case _T('l'):
					strLstFile = CString(optarg);
					break;
				case _T('t'):
					strTxtFile = CString(optarg);
					break;
				case _T('h'):
					Usage();
					break;
				}
			}
			argc -= optind;
			argv += optind;

			if (argc < 1)
			{
				TCHAR curDir[_MAX_PATH];
				GetCurrentDirectory(_MAX_PATH, curDir);
				strStartPath = CString(curDir);
			}
			else
			{
				//_tprintf(_T(" : %s\n"), argv[0]);
				int l = _tcslen(argv[0]);
				//_tprintf(_T(": %d\n  : [%c][%x] [%c][%x]"), l, argv[0][l-2], argv[0][l-2], argv[0][l-1], argv[0][l-1] );
				//       Conemu  FAR,      <\">
				// (          )
				if (argv[0][l-1] == _T(' ') && argv[0][l-2] == _T('"'))
				{
					argv[0][l-2] = 0;
				}
				strStartPath = CString(argv[0]);
			}
			strStartPath.Trim(_T('"'));
			file_lst = _tfopen(strLstFile, _T("wt"));
			file_txt = _tfopen(strTxtFile, _T("wt"));
			if (file_lst == NULL)
			{
				_tprintf(_T("   %s\n"), strLstFile);
			}
			else if (file_txt == NULL)
			{
				_tprintf(_T("   %s\n"), strTxtFile);
			}
			else
			{
				if (bCSV)
				{
					_ftprintf(file_lst, _T("Image Path; Image Name; OSType; Bootable; LogDisk; Path in Img; Name; Blk Size; Addr; Size;\n"));
				}
				ScanDir(strStartPath);
				_tprintf(_T("\n"));
				fclose(file_lst);
				fclose(file_txt);
			}
		}
	}
	else
	{
		// TODO:      
		_tprintf(_T(" :   GetModuleHandle\n"));
		nRetCode = 1;
	}

	return nRetCode;
}

void Usage()
{
	_tprintf(_T("BKDL v1.0      .\n"));
	_tprintf(_T(":\n"));
	_tprintf(_T("BKDL -h | --help\n"));
	_tprintf(_T("    .\n"));
	_tprintf(_T("BKDL [-r][-l_][-t_][]\n"));
	_tprintf(_T("     .\n"));
	_tprintf(_T("-r (--recursive) -        ,\n        .\n"));
	_tprintf(_T("-c (--csv) -    ,\n     .\n"));
	_tprintf(_T("-l_ (--list _) -     ,\n    Files.lst  Files.csv   csv\n"));
	_tprintf(_T("-t_ (--text _) -     ,\n    Files.txt\n"));
	_tprintf(_T(" -       .\n"));
	_tprintf(_T("   ,    .\n"));
	_tprintf(_T("        \n .\n"));
	exit(1);
}

void OutProgress(CString& strPath)
{
	//    80 ,     
	//     30 ,  4   
	//     50 
	int nPathLen = strPath.GetLength();
	CString outPath = strPath;
	if (nPathLen > 50)
	{
		outPath = _T("...") + strPath.Right(47); //47 -  3  
	}
	_tprintf(_T("Images processed: %d; Dir: %-50s\r"), ++nFilesTotal, outPath);
}

BOOL ScanDir(CString strPath)
{
	list<CString> l_Dirs;

	TCHAR pName[_MAX_FNAME];
	TCHAR pExt[_MAX_EXT];

	struct _tfinddata_t c_file;
	intptr_t hFile;
	strPath.TrimRight(_T('\\'));
	if (!bCSV)
	{
		_ftprintf(file_lst, _T("%s\n"), strPath);
	}
	_ftprintf(file_txt, _T("%s\n"), strPath);
	if (_tchdir(strPath) != 0)
	{
		_ftprintf(file_lst, _T("Unable to enter the dir %s\n"), strPath);
		_ftprintf(file_txt, _T("Unable to enter the dir %s\n"), strPath);
		return FALSE;
	}
	OutProgress(strPath);
	if( (hFile = _tfindfirst( _T("*.*"), &c_file )) == -1L )
	{
		_ftprintf(file_lst, _T("Nothing at all in current directory!\n"));
		_ftprintf(file_txt, _T("Nothing at all in current directory!\n"));
	}
	else
	{
		do {
			CString name = CString(c_file.name);
			if (c_file.attrib & _A_SUBDIR)
			{
				if (name == _T(".") || name == _T(".."))
					continue;
				CString strPathDir = strPath + _T("\\") + name;
				l_Dirs.push_back(strPathDir);
			}
			else
			{
				_tsplitpath_s (c_file.name, NULL, 0, NULL, 0, pName, _MAX_FNAME, pExt, _MAX_EXT);
				CString strExt = CString(pExt).MakeLower();
				for (int n = 0; n < KNOWN_EXTS; n++)
				{
					if (strExt == pstrExts[n])
					{
						CString strName = CString(pName) + strExt;
						g_strImgPathName = strPath + _T("\\") + strName;
						IMAGE_TYPES type = ParseImage(0);
						if (type == IMAGE_TYPE_ERROR)
						{
							_ftprintf(file_lst, _T("%s = Read Error!\n"), strName);
							_ftprintf(file_txt, _T("%s = Read Error!\n"), strName);
						}
						else
						{
							if (!bCSV)
							{
								CString strFormat = GetImageFormat(type);
								CString strBootable = (g_bImageBootable) ? _T("; Bootable") : _T("");
								_ftprintf(file_lst, _T("-------------------------------------------------------------------------\n"));
								_ftprintf(file_lst, _T("%s = Size: %d; Format: %s%s\n"), strName, g_iImageSize, strFormat, strBootable);
							}
							_ftprintf(file_txt, _T("-------------------------------------------------------------------------\n"));
							_ftprintf(file_txt, _T("%s\n"), strName);
							myListCtrl.ClearOverflowFlag();
							if (myListCtrl.SetImgName(g_strImgPathName, 0, g_iImageSize, type, FALSE))
							{
								myListCtrl.SetCSVParams(bCSV);
								myListCtrl.OutDir(0);
							}
							myListCtrl.CloseImage();
							OutProgress(strPath);
						}
					}
				}
			}
		} while( _tfindnext( hFile, &c_file ) == 0 );
		_findclose( hFile );
		if (!bCSV)
		{
			_ftprintf(file_lst, _T("\n\n"));
		}
		_ftprintf(file_txt, _T("\n\n"));
		//     ,     
		if (bRecursive)
		{
			while (!l_Dirs.empty())
			{
				ScanDir(l_Dirs.front());
				l_Dirs.pop_front();
			}
		}
		else
			l_Dirs.clear();
	}

	return TRUE;
}

