#pragma once
#include <list>
#include <vector>

#include "BKDImage.h"
#include "BKDAndos.h"
#include "BKDAodos.h"
#include "BKDCsidos3.h"
#include "BKDMikrodos.h"
#include "BKDMkdos.h"
#include "BKDNord.h"
#include "BKDRT11.h"
#include "BKDNCdos.h"

struct PaneInfo {
	int nParentDir;
	int nCurDir;
	int nCurItem;
};

struct BKDir {
	CString name;
	int num;
	BOOL bLogDisk;
	long nBaseOffset;
	long nSize;
};

class CMyListCtrl
{
	static int m_nRecursionCount;
	CBKDImage *m_bkdImage;
	vector<CBKDImage*> m_vpImages; //   ,     .

	CString m_strCurrPath; //     .     
	CString m_strImageName; //  
	CString m_strImgPath; //   ,     
	CString m_strOSName;	// ,    
	BOOL m_bOverflow;
	BOOL m_bCSV;

	PaneInfo m_PaneInfo;
	vector<PaneInfo> m_vSelItems;

	//-------------------,   .
	void ClearImgVector(void);
	void PushCurrentImg(void);
	BOOL PopCurrentImg(void);
	void CloseCurrentImage(void) { m_bkdImage->CloseFile(); }
	void ReopenCurrentImage(void) { m_bkdImage->Reset(); }
	long GetBaseOffset(void){ return m_bkdImage->GetBaseOffset(); }
	ULONGLONG GetImgSize(void) { return m_bkdImage->GetImgSize(); }

public:
	CMyListCtrl(void);
	~CMyListCtrl(void);

	BOOL SetImgName(const CString& strName, long nBaseOffset, ULONGLONG nSize, IMAGE_TYPES type, BOOL bLogDisk = FALSE);
	void SetCSVParams(BOOL bCSV);
	BOOL ResetImgName();
	void CloseImage(void);
	void OutDir(int iCurDir);
	void ClearOverflowFlag(){m_nRecursionCount = 0; m_bOverflow = FALSE;}
};

