#include "stdafx.h"
#include "globals.h"

BOOL g_bImageBootable = FALSE;
int g_iImageSize = 0;
CString g_strImgPathName;
CFile g_ImgFile;
FILE *file_txt = NULL;
FILE *file_lst = NULL;
/*  ,   ,   
	0 -  , -1 - 
*/
static char *strID_Andos = "ANDOS ";
static char *strID_DXDOS = "DX-DOS";
static char *strID_FAT12 = "FAT12   ";
static char *strID_Aodos = " AO-DOS ";
static char *strID_Nord = "NORD ";
static char *strID_RT11 = "?BOOT-U-";
static char *strID_RT11Qu = "?QUBOOT-U-";
IMAGE_TYPES ParseImage(long nBaseOffset)
{
	BYTE pSector[512];
	CFile ImgFile;
	IMAGE_TYPES ret = IMAGE_TYPE_UNKNOWN;

	g_bImageBootable = FALSE;
	g_iImageSize = 0;

	if (!ImgFile.Open (g_strImgPathName, CFile::modeRead | CFile::shareDenyWrite))
	{
		return IMAGE_TYPE_ERROR;
	}

	g_iImageSize = (int)ImgFile.GetLength(); //  

	ImgFile.Seek(nBaseOffset, CFile::begin);

	if (ImgFile.Read(pSector, 512) < 512)
	{
		ret = IMAGE_TYPE_ERROR;
	}
	else
	{
		//    
		if (*(WORD*)pSector == 0240 /*NOP*/)
			if (*(WORD*)(pSector + 2) != 5 /*RESET*/)
				g_bImageBootable = TRUE;

		//   
		if (*(WORD*)(pSector + 0400) == 0123456) // 
		{
			//      
			if (pSector[4] == 032 && (*(WORD*)(pSector + 6) == 256 || *(WORD*)(pSector + 6) == 512))
			{ //  
				ret = IMAGE_TYPE_AODOS;
			}
			else if (strncmp(strID_Aodos, (char*)(pSector + 4), strlen(strID_Aodos)) == 0)
			{ //   
				// 1.77   .     . ..   
				ret = IMAGE_TYPE_AODOS;
			}
			else if (strncmp(strID_Nord, (char*)(pSector + 4), strlen(strID_Nord)) == 0)
			{ //,     
				ret = IMAGE_TYPE_NORD;
			}
			/*   AODOS   NORD   MKDOS, 
			     - ,  , .. MKDOS    04..012
			 ,     ,     .
			  ,  ,           ,
			   -    .
			*/
			else if (*(WORD*)(pSector + 0402) == 051414)
			{
				ret = IMAGE_TYPE_MKDOS;
			}
			//       
			else
			{
				ret = IMAGE_TYPE_MIKRODOS;
			}
		}
		//  .   "FAT12"
		//,   ,   ,    .
		else if ( //   
			(
				((strncmp(strID_Andos, (char*)(pSector + 04), strlen(strID_Andos)) == 0)
				//  		   							    
				&& (pSector[015] == 4) && (*(WORD*)(pSector + 021) == 112) && (pSector[025] == 0371) && (*(WORD*)(pSector+026) == 2))
			) ||
			(strncmp(strID_FAT12, (char*)(pSector + 066), strlen(strID_FAT12)) == 0)
		)
		{
			BYTE nMediaDescriptor = pSector[025];
			char strOEMID[8] = {0};
			strncpy(strOEMID, (char*)(pSector + 4), 7);
			int nBootSize = *(WORD*)&pSector[016] * *(WORD*)&pSector[013];
			ImgFile.Seek(nBaseOffset + nBootSize, CFile::begin);
			BYTE b0,b1;
			ImgFile.Read(&b0, 1); ImgFile.Read(&b1, 1);
			if (b1 == 0xff && b0 == nMediaDescriptor)
			{
				if (strncmp(strID_Andos, strOEMID, strlen(strID_Andos)) == 0)
				{
					ret = IMAGE_TYPE_ANDOS;
				}
				else if (strncmp(strID_DXDOS, strOEMID, strlen(strID_DXDOS)) == 0)
				{
					ret = IMAGE_TYPE_DXDOS;
				}
				else
				{
					ret = IMAGE_TYPE_UNKNOWN; //  MS DOS 
				}
			}
			else
			{
				ret = IMAGE_TYPE_UNKNOWN;
			}
		}
		//    -
		else if (*(WORD*)(pSector + 2) == 012700 && *(WORD*)(pSector + 4) == 0404 && *(WORD*)(pSector + 6) == 0104012)
		{ //-       ,      .
			ret = IMAGE_TYPE_NCDOS;
		}
		else
		{ //  
			//,   11   
			int t = IsRT11(&ImgFile, nBaseOffset, pSector);
			if (t == 1)
			{
				ret = IMAGE_TYPE_RT11;
			}
			else
			{ //,  11
				//,      
				t = IsCSIDOS3(&ImgFile, nBaseOffset, pSector);
				switch (t)
				{
				case 0:
					ret = IMAGE_TYPE_UNKNOWN;
					break;
				case 1:
					ret = IMAGE_TYPE_CSIDOS3;
					break;
				default:
					ret = IMAGE_TYPE_ERROR;
				}
			}
		}
	}

	ImgFile.Close();
	return ret;
}

//  ,   ,    , ..   
//: TRUE - 
//		FALSE -  
BOOL charcompare(BYTE a, BYTE b)
{
	if ('a' <= a && a <= 'z')
	{
		a -= ' '; //    
	}
	if ('a' <= b && b <= 'z')
	{
		b -= ' '; //    
	}
	if (a == b)
		return TRUE;
	return FALSE;
}

BOOL substrfind(BYTE* bufs, size_t len_bufs, BYTE* buff, size_t len_buff)
{
	size_t b_pos = 0; //  .
	size_t s_pos = 0; //  ,  
	size_t t_pos;

	BOOL bOk = FALSE;

	while (b_pos < len_bufs)
	{ //   
		//    
		if (charcompare(bufs[b_pos++], buff[s_pos]))
		{ //.       
			t_pos = b_pos;
			s_pos++; //  ,    
			bOk = TRUE; //       
			while (s_pos < len_buff)
			{ //   
				if (!charcompare(buff[s_pos++], bufs[t_pos++]))
				{ //   
					bOk = FALSE; //  
					break;
				}
			}
			b_pos = t_pos;
			s_pos = 0; //   
			if (bOk)
			{ //    
				break; //  
			}
		}
	}
	//   bOk == TRUE   ,  - FALSE
	return bOk;
}


/*
,   rt11  . :
1 - rt11
0 -  rt11
  ,     c    ,
,           
*/
int IsRT11(CFile* f, long nBaseOffset, BYTE* buf)
{
	int ret = 0;
	//   strID_RT11 -   .
	size_t s_len = strlen(strID_RT11);
	size_t b_len = 512 - s_len;

	BOOL bOk = substrfind(buf, b_len, (BYTE*)strID_RT11, s_len);

	if (bOk)
	{
		ret = 1;
	}
	else
	{
		s_len = strlen(strID_RT11Qu);
		b_len = 512 - s_len;
		bOk = substrfind(buf, b_len, (BYTE*)strID_RT11Qu, s_len);
		if (bOk)
		{
			ret = 1;
		}
	}
	return ret;
}

/*
,     . :
1 - 
0 -  
-1 -  
*/
int IsCSIDOS3(CFile* f, long nBaseOffset, BYTE* buf)
{
	int ret = -1;

	//,      
	if (nBaseOffset + 1024 == f->Seek(nBaseOffset + 1024, CFile::begin))
	{
		if (f->Read (buf, 512) < 512)
		{
			ret = -1;
		}
		else
		{
			if (*(WORD*)(buf + 8) == 0123123 || *(WORD*)(buf + 8) == 0123124)
			{ //    
				if (*(WORD*)(buf + 4) == 0123123 && *(WORD*)(buf + 6) == 0123123) // 3
				{
					ret = 1;
				}
				else
				{
					ret = 0; //     
				}
			}
			else
			{
				ret = 0; //  
			}
		}
	}
	return ret;
}

CString GetImageFormat(IMAGE_TYPES type)
{
	CString strFormat;
	switch (type)
	{
	default:
	case IMAGE_TYPE_UNKNOWN:
		strFormat = _T("Unknown");
		break;
	case IMAGE_TYPE_ANDOS:
		strFormat = _T("ANDOS");
		break;
	case IMAGE_TYPE_MKDOS:
		strFormat = _T("MKDOS");
		break;
	case IMAGE_TYPE_AODOS:
		strFormat = _T("AO-DOS");
		break;
	case IMAGE_TYPE_NORD:
		strFormat = _T("NORD");
		break;
	case IMAGE_TYPE_MIKRODOS:
		strFormat = _T("MicroDOS");
		break;
	case IMAGE_TYPE_CSIDOS3:
		strFormat = _T("CSIDOS3");
		break;
	case IMAGE_TYPE_RT11:
		strFormat = _T("RT-11");
		break;
	case IMAGE_TYPE_NCDOS:
		strFormat = _T("HC-DOS");
		break;
	case IMAGE_TYPE_DXDOS:
		strFormat = _T("DX-DOS");
		break;
	}
	return strFormat;
}
