#pragma once

typedef enum IMAGE_TYPES {
	IMAGE_TYPE_ERROR=-1,
	IMAGE_TYPE_UNKNOWN=0,
	IMAGE_TYPE_ANDOS,
	IMAGE_TYPE_MKDOS,
	IMAGE_TYPE_AODOS,
	IMAGE_TYPE_NORD,
	IMAGE_TYPE_MIKRODOS,
	IMAGE_TYPE_CSIDOS3,
	IMAGE_TYPE_RT11,
	IMAGE_TYPE_NCDOS,
	IMAGE_TYPE_DXDOS
};


typedef enum FILESAVE_STATUS {
	FS_IO_ERROR=-1,
	FS_NO_ERROR=0,
	FS_IMAGE_RO,
	FS_FILE_OPENERR,
	FS_FILE_EXIST,
	FS_STRUCT_ERR,
	FS_CAT_FULL,
	FS_MKD_CAT_FULL,
	FS_DISK_FULL,
	FS_NO_IMAGE
};

extern CFile g_ImgFile; // 
extern FILE *file_txt;
extern FILE *file_lst;
extern BOOL g_bImageBootable;
extern int g_iImageSize;
extern CString g_strImgPathName;

IMAGE_TYPES ParseImage(long nBaseOffset);
BOOL charcompare(BYTE a, BYTE b);
BOOL substrfind(BYTE* bufs, size_t len_bufs, BYTE* buff, size_t len_buff);
int IsRT11(CFile* f, long nBaseOffset, BYTE* buf);
int IsCSIDOS3(CFile* f, long nBaseOffset, BYTE* buf);
CString GetImageFormat(IMAGE_TYPES type);

