#pragma once
#include "BKDImage.h"
#pragma pack(push)
#pragma pack(1)
struct AndosFileRecord {
	BYTE name[8];
	BYTE ext[3];
	BYTE attr;
	BYTE reserved[8];
	BYTE dir_num;
	BYTE parent_dir_num;
	WORD address;
	WORD date;
	WORD first_cluster;
	DWORD length;
};
#pragma pack(pop)

class CBKDAndos :
	public CBKDImage
{
protected:
	int m_nSectorSize;		//   
	int m_nClusterSectors;	//   
	int m_nClusterSize;		//    
	int m_nBootSectors;		//   
	int m_nRootFilesNum;	//     
	int m_nRootSize;		//    
	int m_nFatSectors;		//    
	int m_nFatSize;			//    
	BYTE *m_pFatTbl;
	// 
	int m_nRootSectorOffset;	//  
	int m_nDataSectorOffset;	//  
	//  ,  
	int m_currFat; //  
	int m_nLenClust; //   ,   ,     .

public:
	CBKDAndos(CMyListCtrl* pLC, long nBaseOffset, CString strFileName);
	virtual ~CBKDAndos(void);

	virtual BOOL ReadCatalog();
	virtual CString GetInfo();
	virtual void ExtractFile(FileRecord *sFile, BOOL bExtractAsBin = FALSE);
	virtual FILESAVE_STATUS AddFile(CString& str, int nDirNum, BOOL bAddAsBin = FALSE);
	virtual CString GetSpecificData(DWORD dd);
protected:
	int GetNextFat(int fat);
	void SeekToCluster(CFile *f);
	int FindFreeFat(int fat);
	void SetFat(int fat, WORD val);

	virtual int SeekToPos(CFile *f, int pos);
	virtual void SeekToBeginFile(CFile *f, FileRecord *fr);
	virtual BYTE GetByte(CFile *f, int *len);
	virtual WORD GetWord(CFile *f, int *len);
};

/*
  

	
------------------------------
0		
1-2		  
3-4		  
5-11.	 (7 , .112. )
12.-15.	2  (4 ),  ..

     BPB   .

BPB 

   		
-----------------------------------                            .  .
00		 2		***				   		0240   0753
02		 2		***				    	0436   020220
04		 7		"ANDOS  "		OEM ID ( )
013		 2		512.			   
015		 1		4				   
016		 2 		1				   
020		 1		2				 
021		 2		112.			     
023		 2		***				    
025		 1		0371			Media descriptor
026		 2		2				    
030		 2		10.				   
032		 2		***				 
034		 15. 	0				   
053		 11.	"           "	 
066		 8.		"FAT12   "		  
076		 2		0				   

 

   32. ,    16. .

  
-----------------------------------
0		 8		 .      . :
	0 -    ,
	0345 -   ,    -  
		    .
8		 3		  
11		 1		  (    )
12		 8		
20		 1		     
21		 1		    ,
				 ,     
22		 2		 /    ( - - )
24		 2		  
26		 2		  .      2.
28		 2		 
30		 2		   (   64 )

  -     ,   
,        010, -  -
   

 
0 -  
07777 -   
07760-07766 - 
07767 -  
  -  ,  - ,    

 .
   (  * 3 / 2)
    -   12 ,  -  12

     
 = ( + 1) * 4
*/

