#include "StdAfx.h"
#include "BKDAodos.h"


CBKDAodos::CBKDAodos(CMyListCtrl* pLC, long nBaseOffset, CString strFileName): CBKDImage(pLC, nBaseOffset, strFileName)
{
}


CBKDAodos::~CBKDAodos(void)
{
}

BOOL CBKDAodos::ReadCatalog()
{
	CBKDImage::ReadCatalog();

	if(!m_bFileOpened)
	{
		return FALSE;
	}
	AodosFileRecord curr_record;
	FileRecord curr_fr;

	//  
	g_ImgFile.Seek(m_nBaseOffset + 0, CFile::begin);
	if (g_ImgFile.Read (m_mSector, sizeof(m_mSector)) < sizeof(m_mSector))
	{
		return FALSE;
	}
	int recs_count = 0;
	int files_total = *(WORD*)&m_mSector[FMT_AODOS_CAT_RECORD_NUMBER]; //  - 
	m_sDiskCat.nFreeRecs = (012000 - FMT_AODOS_CAT_BEGIN) / sizeof(AodosFileRecord); //    ,        
	int used_size = 0;

	g_ImgFile.Seek(m_nBaseOffset + FMT_AODOS_CAT_BEGIN, CFile::begin); //   .

	while (--files_total >= 0)
	{
		if (g_ImgFile.Read(&curr_record, sizeof(AodosFileRecord)) < sizeof(AodosFileRecord))
		{
			return FALSE; //    ,    ,   ,
			//    .
		}
		recs_count++;

		if (( curr_record.status1 | curr_record.status2 | curr_record.name[0] | curr_record.name[1]) == 0)
			break; //    1.77

		//  ,       
		curr_fr.nAttr = 0;

		if (curr_record.status2 & 0200)
		{
			curr_fr.nAttr |= FR_ATTR_DELETED;
			recs_count--;
		}
		else if (curr_record.status1 & 0200)
		{
			curr_fr.nAttr |= FR_ATTR_BAD;
			if (curr_record.name[0] == 0)
			{
				curr_record.name[0] = 'B';
				curr_record.name[1] = 'A';
				curr_record.name[2] = 'D';
			}
		}

		CString name = BKToUNICODE((BYTE*)curr_record.name, 14).Trim();
		CString ext = _T("");
		int l = name.GetLength();
		int t = name.ReverseFind(_T('.'));
		if (t >= 0) //  
		{
			ext = name.Right(l - t - 1);
			name = name.Left(t).Trim();
		}
		if (!ext.IsEmpty())
		{
			name += _T(".") + ext;
		}
		curr_fr.strName = name;
		curr_fr.iDirNum = curr_record.status2 & 0x7f;
		if ((curr_record.len_blk == 0) && !(curr_fr.nAttr & FR_ATTR_DELETED))
		{ // 
			curr_fr.nAttr |= FR_ATTR_DIR;
			curr_fr.nRecType = RECORD_TYPE_DIR;
			curr_fr.iDirDir = curr_record.status1 & 0x7f;
			curr_fr.iAddress = 0; //  curr_record.address,     ,
			//       ,   
			curr_fr.iBlkSize = 0;
		}
		else
		{ // 
			curr_fr.nRecType = RECORD_TYPE_FILE;
			curr_fr.iDirDir = 0;
			curr_fr.iAddress = curr_record.address;

			if (curr_fr.nAttr & FR_ATTR_DELETED)
			{
				curr_fr.iDirNum = 0; //      
				//      - .
			}
			else
			{
				if (curr_record.status1 & 1)
				{
					curr_fr.nAttr |= FR_ATTR_PROTECTED;
				}
				if (curr_record.status1 & 2)
				{
					curr_fr.nAttr |= FR_ATTR_HIDDEN;
				}
				used_size += curr_record.len_blk;
				curr_fr.iBlkSize = curr_record.len_blk;
			}
		}

		/*	   .
			..  curr_record.length      0200000,       
			   0200000 ..      128 .(128 == 65536.== 0200000) 
			hw = (curr_record.len_blk >>7 ) << 16; //    
			hw = (curr_record.len_blk / 128) * 65536 = curr_record.len_blk * 512
		*/
/*
 ,       0100000   0200000,    
0100000 == 32768. == 64 .
 , ..         64.
hw = (curr_record.len_blk / 64) * 32768 = curr_record.len_blk * 512
hw = (curr_record.len_blk >> 6) << 15 = curr_record.len_blk * 512
      .    -  16  ,  17
DWORD hw = (curr_record.len_blk  << 9) & 0xffff8000; //    
*/
		DWORD hw = (curr_record.len_blk  << 9) & 0xffff0000; //    
		curr_fr.iSize = hw + curr_record.length; // . + .

		curr_fr.iStartSector = curr_record.start_blok;
		m_sDiskCat.vecFC.push_back(curr_fr);
	}

	m_sDiskCat.nFreeRecs -= recs_count;
	//          0466
	int imgSize = *(WORD*)&m_mSector[FMT_AODOS_DISK_SIZE];
	if ((imgSize == 0) || (imgSize > 32767)) //..    ,     ,        .  .
	{
		/*  .
		800     800 , .. ,  ,
		 -        .
		   ,  ,       ,     ,
		      800.
		*/
		imgSize = max(1600, (int)m_nSize / 512);
	}
	m_sDiskCat.nFreeBlocks = imgSize - 20 - used_size;
	return TRUE;
}

FILESAVE_STATUS CBKDAodos::AddFile(CString& str, int nDirNum, BOOL bAddAsBin)
{
	if (m_bFileROMode)
	{ //     ,
		return FS_IMAGE_RO; //       .
	}
	CFile inFile;
	FILESAVE_STATUS bRet = FS_IO_ERROR;
	UINT CatOffs = 0; //   ,     .
	int FileAddr, FileSize;

	UINT nCatSize = 012 * 512; //  -  10. .  10  - ,    20. 
	AodosFileRecord mFR;
	ZeroMemory(&mFR, sizeof(AodosFileRecord));

	if (inFile.Open (str, CFile::modeRead | CFile::shareDenyWrite))
	{
		FileSize = (int)inFile.GetLength();
		CString name = inFile.GetFileName();
		CString ext = _T("");
		int l = name.GetLength();
		int t = name.ReverseFind(_T('.'));
		if (t >= 0) //  
		{
			ext = name.Right(l - t - 1);
			name = name.Left(t);
		}
		//,      ?
		inFile.Read(m_mBinHeader, sizeof(m_mBinHeader));
		if (((ext.CompareNoCase(_T("BIN"))== 0) || bAddAsBin) && (m_mBinHeader[1] == FileSize - 4)) //    
		{ //,  
			FileAddr = m_mBinHeader[0];
			FileSize = m_mBinHeader[1];
			//      .bin
			t = name.ReverseFind(_T('.'));
			if (t >= 0)
			{
				l = name.GetLength();
				ext = name.Right(l - t - 1);
				name = name.Left(t);
			}
		}
		else
		{ //,  
			inFile.Seek(0, CFile::begin);
			FileAddr = 01000;
		}
		if (!ext.IsEmpty())
		{
			name += _T(".") + ext;
		}
		UNICODEtoBK(name, mFR.name, 14, TRUE);
		mFR.status2 = nDirNum & 0x7f; //   
		mFR.address = FileAddr; //,     ,    
		mFR.len_blk = FileSize / 01000; //  
		mFR.length = FileSize % 0200000; //     65535
		if (m_sDiskCat.nFreeBlocks * 01000 < ((FileSize) ? (((FileSize - 1) | 0777) + 1) : 0))
		{
			inFile.Close();
			return FS_DISK_FULL;
		}
	}
	else
		return FS_FILE_OPENERR;

	BYTE *pCat = new BYTE[nCatSize];
	ZeroMemory(pCat, nCatSize);
	//  ,      
	AodosFileRecord *pAOCat = (AodosFileRecord *)(pCat + FMT_AODOS_CAT_BEGIN);
	UINT nAOCatSize = (nCatSize - FMT_AODOS_CAT_BEGIN) / sizeof(AodosFileRecord);
	/*
	1.  .
	2.     
	3.  , ,      
	4.   ,  
	5.    ,   
	6.  .
	7.  .
	*/
	UINT nRecs;
	//   
	g_ImgFile.Seek(m_nBaseOffset + 0, CFile::begin);
	// 
	if (nCatSize == g_ImgFile.Read (pCat, nCatSize))
	{
		nRecs = *(WORD*)&pCat[FMT_AODOS_CAT_RECORD_NUMBER]; // -   , + 1 -   2.10   
		/*
		      ,   FMT_AODOS_CAT_RECORD_NUMBER  
		     ,     .
		   .       ,    nRecs  ==  .
		*/
		//,      .
		UINT tc = 0;
		BOOL bFound = FALSE;
		while ((tc <= nRecs) && (tc < nAOCatSize))
		{
			if (( pAOCat[tc].status1 | pAOCat[tc].status2 | pAOCat[tc].name[0] | pAOCat[tc].name[1]) == 0)
			{
				break; //    1.7 (  .)
			}
			if (pAOCat[tc].status2 & 0200)
			{
				//  .
			}
			else if (!strncmp((char*)mFR.name, (char*)pAOCat[tc].name, 14))
			{
				bFound = TRUE;
				break;
			}
			tc++;
		}
		if (bFound)
		{
			bRet = FS_FILE_EXIST;
		}
		else
		{
			//    .
			UINT nFirstFreeBlock = 0;
			tc = 0;
			bFound = FALSE;
			while ((tc <= nRecs) && (tc < nAOCatSize))
			{
				if (pAOCat[tc].status2 & 0200)
				{
					if (pAOCat[tc].len_blk >= mFR.len_blk)
					{	//    
						bFound = TRUE;
						CatOffs = tc;
						nFirstFreeBlock = pAOCat[tc].start_blok;
						break;
					}
				}
				tc++;
			}

			if (bFound)
			{
				// 
				mFR.start_blok = nFirstFreeBlock;
				//  
				g_ImgFile.Seek(m_nBaseOffset + nFirstFreeBlock * 512, CFile::begin);
				int nReaded;
				do {
					ZeroMemory(m_mBlock, COPY_BLOCK_SIZE);
					nReaded = inFile.Read(m_mBlock, COPY_BLOCK_SIZE);
					//    .
					g_ImgFile.Write(m_mBlock, ((nReaded) ? (((nReaded - 1) | 0777) + 1) : 0));
					FileSize -= nReaded;
				} while(FileSize > 0);
				bRet = FS_NO_ERROR;
			}
			else
				bRet = FS_CAT_FULL;
		}
	}
	inFile.Close();
	if (bRet == FS_NO_ERROR)
	{	//   ,  
		UINT nHoleZize;
		if ((nHoleZize = pAOCat[CatOffs].len_blk) > mFR.len_blk)
		{	// 
			*(WORD*)&pCat[FMT_AODOS_CAT_RECORD_NUMBER] += 1;
			//  
			UINT tc = 0;
			if (CatOffs == nRecs)
			{
				tc = CatOffs + 1;
			}
			else
			{
				while ((tc <= nRecs) && (tc < nAOCatSize))
				{
					if (( pAOCat[tc].status1 | pAOCat[tc].status2 | pAOCat[tc].name[0] | pAOCat[tc].name[1]) == 0)
						break;
					tc++;
				}
			}
			if (tc >= nAOCatSize) //   
			{
				bRet = FS_CAT_FULL;
			}
			else
			{	//
				int cnt = 0; //
				while (tc > CatOffs)
				{
					pAOCat[tc] = pAOCat[tc-1];
					tc--;
					cnt++;
				}
				//  
				pAOCat[CatOffs] = mFR;
				AodosFileRecord hole;
				ZeroMemory(&hole, sizeof(AodosFileRecord));
				hole.status1 = 0377;
				hole.status2 = 0377;
				strcpy_s((char*)hole.name, 14, "<UNUSED>");
				hole.start_blok = mFR.start_blok + mFR.len_blk;
				hole.len_blk = nHoleZize - mFR.len_blk;
				hole.length = (hole.len_blk * 512) % 0200000;
				//     
				pAOCat[CatOffs+1] = hole;
				//    ,      -      
				//          032
				if (cnt == 1)
				{
					*(WORD*)&pCat[FMT_AODOS_FIRST_FREE_BLOCK] = hole.start_blok;
				}
			}
		}
		else
		{	//   , 
			//  
			pAOCat[CatOffs] = mFR;
		}

		if (bRet == FS_NO_ERROR)
		{
			//  
			g_ImgFile.Seek(m_nBaseOffset + 0, CFile::begin);
			g_ImgFile.Write(pCat, nCatSize);
			g_ImgFile.Write(pCat, nCatSize); //  , .
		}
	}
	delete [] pCat;
	return bRet;
}
