#include "StdAfx.h"
#include "BKDCsidos3.h"


CBKDCsidos3::CBKDCsidos3(CMyListCtrl* pLC, long nBaseOffset, CString strFileName): CBKDImage(pLC, nBaseOffset, strFileName)
{
}


CBKDCsidos3::~CBKDCsidos3(void)
{
}

BOOL CBKDCsidos3::ReadCatalog()
{
	CBKDImage::ReadCatalog();

	if(!m_bFileOpened)
	{
		return FALSE;
	}
	CsidosFileRecord curr_record;
	FileRecord curr_fr;

	//  2 
	if (m_nBaseOffset + 512*2 != g_ImgFile.Seek(m_nBaseOffset + 512*2, CFile::begin))
	{
		return FALSE;
	}
	//  8 .       ,     .
	//  12. ,   20. .    25. .
	int used_size = 0;
	int recs_count = 0;
	int sect_count = 8;
	int disk_size = 0;
	m_sDiskCat.nFreeRecs = 25 * sect_count; //    ,        
	BOOL bEoc = FALSE;
	BOOL bFirstRead = TRUE;
	while ((--sect_count >= 0) && !bEoc)
	{	//  .
		if (g_ImgFile.Read (m_mSector, 12) != 12) //   
		{
			return FALSE;
		}
		if (bFirstRead)
		{	//    ,        
			bFirstRead = FALSE;
			disk_size = *(WORD*)&m_mSector[2];
		}
		int rec_count = 25;
		while (--rec_count >= 0)
		{ //    
			if (g_ImgFile.Read (&curr_record, sizeof(CsidosFileRecord)) < sizeof(CsidosFileRecord))
			{
				return FALSE; //    ,    ,   ,
							//    .
			}
			if (curr_record.type == 0)
			{ // 
				bEoc = TRUE;
				break;
			}
			int nDirNum = 0;
			curr_fr.nAttr = 0;
			if (curr_record.type == 0376)
			{//
				continue; //
			}
			else if (curr_record.type == 0312)
			{//   
				continue; //
			}
			else if (curr_record.type == 0377)
			{// ,   
				curr_fr.nAttr |= FR_ATTR_DELETED;
				recs_count--;
			}
			else if (curr_record.type == 0311)
			{// 
				curr_fr.nAttr |= FR_ATTR_BAD;
				if (curr_record.name[0] == 0)
				{
					curr_record.name[0] = 'B';
					curr_record.name[1] = 'A';
					curr_record.name[2] = 'D';
				}
			}
			else if ((curr_record.type >= 1) && (curr_record.type <= 0310))
			{//  
				nDirNum = curr_record.type - 1;
			}
			recs_count++;

			if ((curr_record.start_block | curr_record.address | curr_record.length) == 0)
			{// 
				curr_fr.nAttr |= FR_ATTR_DIR;
				curr_fr.nRecType = RECORD_TYPE_DIR;
				curr_fr.strName = BKToUNICODE((BYTE*)curr_record.name, 11).Trim();
				curr_fr.iDirNum = nDirNum;
				curr_fr.iDirDir = curr_record.status - 1;
				curr_fr.iBlkSize = 0;
				curr_fr.nSpecificData = 0;
			}
			else
			{// 
				curr_fr.nRecType = RECORD_TYPE_FILE;
				curr_fr.strName = BKToUNICODE((BYTE*)curr_record.name, 8).Trim();
				CString ext = BKToUNICODE((BYTE*)curr_record.name + 8, 3).Trim();
				if (!ext.IsEmpty())
				{
					curr_fr.strName += _T(".") + ext;
				}
				curr_fr.iDirNum = nDirNum;
				curr_fr.iDirDir = 0;
				curr_fr.nSpecificData = curr_record.status & 0177;
			}

			if ((char)curr_record.protection < 0) //     (curr_record.protection & 0200)
			{//  
				curr_fr.nAttr |= FR_ATTR_PROTECTED;
			}
			curr_fr.iAddress = curr_record.address;
			if (curr_record.status & 0200)
			{//   
				curr_fr.iSize = curr_record.length * 512;
			}
			else
			{
				curr_fr.iSize = curr_record.length;
			}
			if (!(curr_fr.nAttr & FR_ATTR_DELETED) && curr_fr.iSize)
			{
				curr_fr.iBlkSize = (curr_fr.iSize) ? ((((curr_fr.iSize - 1) | 0777) + 1) / 01000) : 0;
				used_size += curr_fr.iBlkSize;
			}
			curr_fr.iStartSector = curr_record.start_block;
			m_sDiskCat.vecFC.push_back(curr_fr);
		}
	}
	m_sDiskCat.nFreeRecs -= recs_count;
	m_sDiskCat.nFreeBlocks = disk_size - 012 - used_size;
	return bEoc;
}

// , ,     
FILESAVE_STATUS CBKDCsidos3::ReadCat(CsidosFileRecord *buf)
{
	FILESAVE_STATUS bRet = FS_IO_ERROR;
	ZeroMemory(buf, 8 * 25 * sizeof(CsidosFileRecord));

	CsidosFileRecord bcfr;
	//  2 
	if (m_nBaseOffset + 512*2 == g_ImgFile.Seek(m_nBaseOffset + 512*2, CFile::begin))
	{	// 
		UINT tc = 0;
		for (int sect_count = 0; sect_count < 8; sect_count++)
		{
			if (m_nBaseOffset + 512*(2 + sect_count) + 12 != g_ImgFile.Seek(12, CFile::current))
				return bRet;
			for (int rec_count = 0; rec_count < 25; rec_count ++)
			{
				if (sizeof(CsidosFileRecord) != g_ImgFile.Read(&bcfr, sizeof(CsidosFileRecord)))
				{
					return bRet;
				}
				if (bcfr.type == 0) //  ,    .
				{
					return FS_NO_ERROR;
				}
				if (bcfr.type != 0312) //    ,    .
				{
					buf[tc++] = bcfr;
				}
			}
		}
		bRet = FS_NO_ERROR;
	}
	return bRet;
}

// 
FILESAVE_STATUS CBKDCsidos3::WriteCat(CsidosFileRecord *buf)
{
	FILESAVE_STATUS bRet = FS_IO_ERROR;
	//  2 
	if (m_nBaseOffset + 512*2 == g_ImgFile.Seek(m_nBaseOffset + 512*2, CFile::begin))
	{	// 
		UINT tc = 0;
		for (int sect_count = 0; sect_count < 8; sect_count++)
		{
			if (m_nBaseOffset + 512*(2 + sect_count) + 12 != g_ImgFile.Seek(12, CFile::current))
				return bRet;
			g_ImgFile.Write(buf+tc, 25*sizeof(CsidosFileRecord));
			tc += 25;
		}
		bRet = FS_NO_ERROR;
	}
	return bRet;
}
//      .
//:
// -1 -   
// 0 -   
// 1 -   
int CBKDCsidos3::CompareSize(CsidosFileRecord *cfr, UINT fileSize)
{
	UINT fl = (cfr->status & 0200) ? ((fileSize) ? (((fileSize - 1) | 0777) + 1) : 0) / 01000 : fileSize;
	if (cfr->length > fl)
	{
		return 1;
	}
	else if (cfr->length == fl)
	{
		return 0;
	}
	else
		return -1;
}

int CBKDCsidos3::GetLength(CsidosFileRecord *cfr)
{
	if (cfr->status & 0200)
	{ //  
		return cfr->length * 01000;
	}
	else
	{
		return cfr->length;
	}

}
void CBKDCsidos3::SetLength(CsidosFileRecord *cfr, UINT fileSize)
{
	if (fileSize > 65535)
	{
		cfr->length = (((fileSize - 1) | 0777) + 1) / 01000; //  
		cfr->status |= 0200;
	}
	else
	{
		cfr->status &= ~0200;
		cfr->length = fileSize;
	}
}

FILESAVE_STATUS CBKDCsidos3::AddFile(CString& str, int nDirNum, BOOL bAddAsBin)
{
	if (m_bFileROMode)
	{ //     ,
		return FS_IMAGE_RO; //       .
	}
	CFile inFile;
	FILESAVE_STATUS bRet = FS_IO_ERROR;
	int FileAddr, FileSize;

	UINT nCatSize = 8 * 25;
	UINT CatOffs = 0; //   ,     .
	CsidosFileRecord cFR;
	ZeroMemory(&cFR, sizeof(CsidosFileRecord));

	if (inFile.Open (str, CFile::modeRead | CFile::shareDenyWrite))
	{
		FileSize = (int)inFile.GetLength();
		CString name = inFile.GetFileName();
		CString ext = _T("");
		int l = name.GetLength();
		int t = name.ReverseFind(_T('.'));
		if (t >= 0) //  
		{
			ext = name.Right(l - t - 1);
			name = name.Left(t);
		}
		//,      ?
		inFile.Read(m_mBinHeader, sizeof(m_mBinHeader));
		if (((ext.CompareNoCase(_T("BIN"))== 0) || bAddAsBin) && (m_mBinHeader[1] == FileSize - 4)) //    
		{ //,  
			FileAddr = m_mBinHeader[0];
			FileSize = m_mBinHeader[1];
			//      .bin
			t = name.ReverseFind(_T('.'));
			if (t >= 0)
			{
				l = name.GetLength();
				ext = name.Right(l - t - 1);
				name = name.Left(t);
			}
		}
		else
		{ //,  
			inFile.Seek(0, CFile::begin);
			FileAddr = 01000;
		}
		UNICODEtoBK(name, cFR.name, 8, TRUE);
		UNICODEtoBK(ext, &cFR.name[8], 3, TRUE);
		cFR.type = nDirNum+1; //   
		cFR.address = FileAddr; //,     ,    
		cFR.status = 044; // 2   0,  4   1
		SetLength(&cFR, FileSize);

		if (m_sDiskCat.nFreeBlocks * 01000 < ((FileSize) ? (((FileSize - 1) | 0777) + 1) : 0))
		{
			inFile.Close();
			return FS_DISK_FULL;
		}
	}
	else
		return FS_FILE_OPENERR;

	CsidosFileRecord* pCat = new CsidosFileRecord[nCatSize];
	/*
	1.  .
	2.     
	3.  , ,      
	4.   ,  
	5.    ,   
	6.  .
	7.  .
	*/
	// 
	if (FS_NO_ERROR == ReadCat(pCat))
	{
		//,      .
		UINT tc = 0;
		BOOL bFound = FALSE;
		for (int rec_count = 0; rec_count < 8 * 25; rec_count++)
		{
			if (pCat[tc].type == 0)
			{
				break;
			}
			if (!strncmp((char*)cFR.name, (char*)pCat[tc].name, 11))
			{
				bFound = TRUE;
				break;
			}
			tc++;
		}
		if (bFound)
		{
			bRet = FS_FILE_EXIST;
		}
		else
		{
			//    
			UINT r377 = 0; //   0377
			CatOffs = 0;
			bFound = FALSE;
			UINT nFirstFreeBlock = 0;
			for (int i = 0; i < 8*25; i++)
			{
				if (pCat[CatOffs].type == 0)
					break;	// 
				else if (pCat[CatOffs].type == 0377 && CompareSize(&pCat[CatOffs], FileSize) >= 0)
				{
					if (r377 == 0)
					{
						r377 = CatOffs; //   
					}
				}
				else if (pCat[CatOffs].type == 0376 && CompareSize(&pCat[CatOffs], FileSize) >= 0)
				{
					bFound = TRUE;
					break;
				}
				CatOffs++;
			}
			//   ,   ,   ,
			//  - ,      .
			if (!bFound && (r377 != 0))
			{
				bFound = TRUE;
				CatOffs = r377;
			}
			if (bFound)
			{
				nFirstFreeBlock = pCat[CatOffs].start_block;
				// 
				cFR.start_block = nFirstFreeBlock;
				//  
				g_ImgFile.Seek(m_nBaseOffset + nFirstFreeBlock * 512, CFile::begin);
				int nReaded;
				do {
					ZeroMemory(m_mBlock, COPY_BLOCK_SIZE);
					nReaded = inFile.Read(m_mBlock, COPY_BLOCK_SIZE);
					//    .
					g_ImgFile.Write(m_mBlock, ((nReaded) ? (((nReaded - 1) | 0777) + 1) : 0));
					FileSize -= nReaded;
				} while(FileSize > 0);
				bRet = FS_NO_ERROR;
			}
			else
				bRet = FS_CAT_FULL;
		}
	}
	inFile.Close();
	if (bRet == FS_NO_ERROR)
	{	//   ,  
		UINT nHoleZize = GetLength(&pCat[CatOffs]);
		UINT len = GetLength(&cFR);
		if (nHoleZize > len)
		{	// 
			UINT tc = 0;
			//  
			for (int i = 0; i < 8*25; i++)
			{
				if (pCat[i].type == 0)
				{
					tc = i;
					break;
				}
			}
			if ((tc == 0) || (tc >= 8*25-1))
			{
				bRet = FS_CAT_FULL;
			}
			else
			{
				//
				while (tc > CatOffs)
				{
					pCat[tc] = pCat[tc-1];
					tc--;
				}
				//  
				pCat[CatOffs] = cFR;
				CsidosFileRecord hole;
				ZeroMemory(&hole, sizeof(CsidosFileRecord));
				hole.type = 0376;

				hole.start_block = cFR.start_block + ((len) ? (((len - 1) | 0777) + 1) : 0) / 01000;
				SetLength (&hole, nHoleZize - len);
				//     
				pCat[CatOffs+1] = hole;
			}
		}
		else
		{	//   , 
			//  
			pCat[CatOffs] = cFR;
		}

		if (bRet == FS_NO_ERROR)
		{
			//  
			bRet = WriteCat(pCat);
		}
	}
	delete [] pCat;
	return bRet;
}

CString CBKDCsidos3::GetSpecificData(DWORD dd)
{
	CString str;
	if (dd)
	{
		if (dd & 010)
		{
			int p0 = (dd >> 4) & 7;
			int p1 = dd & 7;
			str.Format(_T("10; %d:%d"), p0, p1);
		}
		else
		{
			int p0 = (dd >> 4) & 7;
			int p1 = dd & 7;
			str.Format(_T("11; %d:%d"), p0, p1);
		}
	}
	else
	{
		str = _T("");
	}

	return str;
}

