#pragma once
#include "BKDImage.h"
#pragma pack(push)
#pragma pack(1)
struct CsidosFileRecord {
	BYTE type;		// ,    -
	BYTE protection;// <0 -   
	BYTE name[11];	//   ,   
	BYTE status;	// .
	WORD start_block;// 
	WORD address;	// 
	WORD length;	// ,    ,   
};
#pragma pack(pop)

class CBKDCsidos3 :
	public CBKDImage
{
public:
	CBKDCsidos3(CMyListCtrl* pLC, long nBaseOffset, CString strFileName);
	virtual ~CBKDCsidos3(void);

	virtual BOOL ReadCatalog();
	FILESAVE_STATUS ReadCat(CsidosFileRecord *buf);
	FILESAVE_STATUS WriteCat(CsidosFileRecord *buf);
	int CompareSize(CsidosFileRecord *cfr, UINT fileSize);
	int GetLength(CsidosFileRecord *cfr);
	void SetLength(CsidosFileRecord *cfr, UINT fileSize);
	virtual FILESAVE_STATUS AddFile(CString& str, int nDirNum, BOOL bAddAsBin = FALSE);
	virtual CString GetSpecificData(DWORD dd);
};

/*
   

00  -  
02-011  - 
012-...   

   

 
  
------------------------------
0		2		  
2		2		    
4		2		0123123  csidos-3
6		2		0123123  csidos-3
010		2		0123123    csidos
012		2		  == 0
014		0764	  

 
  
------------------------------
0		2		  
2		012		  == 0
014		0764	  


    (024 )

  
------------------------------
0		1		:
				1-0310  ,    . 1 - .
				0311  
				0376 
				0312    
				0377  ,   
				0  
1		1		<0 -   
2		013		    ( )
015		1		 :
				7  -    
				3  -    0010
				  -   0177717 ()
				    
016		2		  , 0  
020		2		 , 0  
022		2		 , 0  

       .

*/