#include "StdAfx.h"
#include "BKDMikrodos.h"


CBKDMikrodos::CBKDMikrodos(CMyListCtrl* pLC, long nBaseOffset, CString strFileName): CBKDImage(pLC, nBaseOffset, strFileName)
{
}


CBKDMikrodos::~CBKDMikrodos(void)
{
}

BOOL CBKDMikrodos::ReadCatalog()
{
	CBKDImage::ReadCatalog();

	if(!m_bFileOpened)
	{
		return FALSE;
	}
	MikrodosFileRecord curr_record;
	FileRecord curr_fr;

	//  
	g_ImgFile.Seek(m_nBaseOffset + 0, CFile::begin);
	if (g_ImgFile.Read (m_mSector, sizeof(m_mSector)) < sizeof(m_mSector))
	{
		return FALSE;
	}
	int recs_count = 0;
	int files_total = *(WORD*)&m_mSector[FMT_MIKRODOS_CAT_RECORD_NUMBER]; //  - .
	m_sDiskCat.nFreeRecs = (012000 - FMT_MIKRODOS_CAT_BEGIN) / sizeof(MikrodosFileRecord); //    ,        
	int used_size = 0;

	g_ImgFile.Seek(m_nBaseOffset + FMT_MIKRODOS_CAT_BEGIN, CFile::begin); //   .

	while (--files_total >= 0)
	{
		if (g_ImgFile.Read (&curr_record, sizeof(MikrodosFileRecord)) < sizeof(MikrodosFileRecord))
		{
			return FALSE; //    ,    ,   ,
			//    .
		}
		recs_count++;
		//  ,       
		curr_fr.nAttr = 0;

		if (curr_record.dir_dir & 0200)
		{
			curr_fr.nAttr |= FR_ATTR_BAD;
			if (curr_record.name[0] == 0)
			{
				curr_record.name[0] = 'B';
				curr_record.name[1] = 'A';
				curr_record.name[2] = 'D';
			}
		}

		if ((curr_record.name[0] == 0177) || (curr_record.len_blk == 0))
		{ // 
			curr_fr.nAttr |= FR_ATTR_DIR;
			curr_fr.nRecType = RECORD_TYPE_DIR;
			if (curr_record.name[0] == 0177)
			{
				curr_fr.strName = BKToUNICODE((BYTE*)curr_record.name + 1, 13).Trim();
			}
			else
			{
				curr_fr.strName = BKToUNICODE((BYTE*)curr_record.name, 14).Trim();
			}
			curr_fr.iDirNum = curr_record.dir_num & 0x7f;
			curr_fr.iDirDir = curr_record.dir_dir & 0x7f;
			curr_fr.iAddress = 0; //  curr_record.address,     ,
			//       ,   
			curr_fr.iBlkSize = 0;
		}
		else
		{ // 
			curr_fr.nRecType = RECORD_TYPE_FILE;
			CString name = BKToUNICODE((BYTE*)curr_record.name, 14).Trim();
			CString ext = _T("");
			int l = name.GetLength();
			int t = name.ReverseFind(_T('.'));
			if (t >= 0) //  
			{
				ext = name.Right(l - t - 1);
				name = name.Left(t).Trim();
			}
			if (!ext.IsEmpty())
			{
				name += _T(".") + ext;
			}
			curr_fr.strName = name;
			curr_fr.iDirNum = 0; //curr_record.dir_num & 0x7f;
			curr_fr.iDirDir = 0;
			curr_fr.iAddress = curr_record.address;
			used_size += curr_record.len_blk;
			curr_fr.iBlkSize = curr_record.len_blk;
		}

		/*	   .
			..  curr_record.length      0200000,       
			   0200000 ..      128 .(128 == 65536.== 0200000) 
		
		hw = (curr_record.len_blk >>7 ) << 16; //    
		hw = (curr_record.len_blk / 128) * 65536 = curr_record.len_blk * 512
		*/
		DWORD hw = (curr_record.len_blk  << 9) & 0xffff0000; //    
		curr_fr.iSize = hw + curr_record.length; // . + .

		curr_fr.iStartSector = curr_record.start_blok;
		m_sDiskCat.vecFC.push_back(curr_fr);
	}

	m_sDiskCat.nFreeRecs -= recs_count;
	m_sDiskCat.nFreeBlocks = *(WORD*)&m_mSector[FMT_MIKRODOS_DISK_SIZE] - 10 - used_size;

	return TRUE;
}


