#pragma once
#include "BKDImage.h"
#pragma pack(push)
#pragma pack(1)
struct NCdosFileRecord {
	BYTE name[16];	// ,    "//",    .
	WORD address;	// 
	WORD length;	//
	WORD unk1;		// 
};
#pragma pack(pop)

#define DISKMAP_SIZE 800
#define BLOCK_SIZE 1024

class CBKDNCdos :
	public CBKDImage
{
protected:
	BYTE* m_pDiskMap;
	//  ,  
	int m_currBlock; //  
	int m_nLenBlock; //   ,   ,     .

	int GetStartBlock(int fn);
	int GetNextBlock(int blk);
	void SeekToBlock(CFile *f);

	virtual int SeekToPos(CFile *f, int pos);
	virtual void SeekToBeginFile(CFile *f, FileRecord *fr);
	virtual BYTE GetByte(CFile *f, int *len);
	virtual WORD GetWord(CFile *f, int *len);

public:
	CBKDNCdos(CMyListCtrl* pLC, long nBaseOffset, CString strFileName);
	virtual ~CBKDNCdos(void);

	virtual void ExtractFile(FileRecord *sFile, BOOL bExtractAsBin = FALSE);
	virtual BOOL ReadCatalog();

};

/*
0  - 
  01000 (  )   ,
 01440 (800.) .
    (2 ).  -  , 
 .     ,   .
 .      ,     
    .

  02440  ,   .
  010000  .

   22. ,     -
  ,   "//",  .   
,   2,   - 1, 0 - .
      ,   ,  ,
 ,      1,    

,     ,   ,  ,
    , 

.		
--------------------------------
0		16.		  
16.		2		  
18.		2		 ,      64?
20.		2		,  ,    2  

	nop
	mov #404,r0
	emt 12
	mov #177,r0
	emt 12
	mov #11,r0 		;     10*
	mov #14000,r1   ;     11000*
	mov #110000,r2  ;   
	mov #2000,r3 	;    
	call @#160004   ;-   
	bcs 0x3e
	mov #33,r0		; 32*
	mov	#4000,r1    ; 5000*
	mov #60000,r2
	mov #2000,r3
	call @#160004   ;-   
	bcs 0x3e
	jmp @#110000
0x3e: mov pc,r0
	add #10,r0
	emt 65
	halt
	asciz "\r\n*    *\r\n"

,   .      .


*/
