#pragma once
#include "BKDImage.h"
#pragma pack(push)
#pragma pack(1)
struct NordFileRecord{
	BYTE status;	// ,     -
	BYTE dir_num;	// ,   
	BYTE name[14];	// /,     0177 -  .
	WORD start_blok;// 
	WORD len_blk;	//  
	WORD address;	// 
	WORD length;	//
};
#pragma pack(pop)

class CBKDNord :
	public CBKDImage
{
	int m_nVersion;	// .
public:
	CBKDNord(CMyListCtrl* pLC, long nBaseOffset, CString strFileName);
	virtual ~CBKDNord(void);

	virtual BOOL ReadCatalog();
	virtual FILESAVE_STATUS AddFile(CString& str, int nDirNum, BOOL bAddAsBin = FALSE);
	virtual void SeekToBeginFile(CFile *f, FileRecord *fr);
};

#define FMT_NORD_BEGIN_BLOCK 026
#define FMT_NORD_CAT_RECORD_NUMBER 030
#define FMT_NORD_FIRST_FREE_BLOCK 032
#define FMT_NORD_WRITE_PROTECT_MARKER 034
#define FMT_NORD_DISK_TYPE 042
#define FMT_NORD_CAT_NUMBER 044
#define FMT_NORD_DISK_SIZE 0466
#define FMT_NORD_CAT_BEGIN 0500
/*
  - .
 0-011 - , 012-023 -  
  - 012(10.) 
 :

	
------------------------------------------
026		o  ooo aaoa o oep ceopa 
		aaoa oecoo ca
		NORD 3.5: (o aee coyec
		 aoaeco opao aaoa
		oecoo ca, oa o copoa a
		eoe a pyoe ecoe ycpoco)
030		 -    (   
		  )
		NORD 3.5:
		oee oeco e  aaoe (e! a!
		yaee a.   . -      ,
		..      . );
032		       .
		     ,         + 1 
		    .       .
034		    ,    0123456
		  
036		NORD 3.5:
		ea aa copoce cooo a apyoo
		ce (036 - cooa A:, 037 - B:);

042		 :
		0 - 80 . 2 
		1 - 40 . 2 
		2 - 80 . 1 
		3 - 40 . 1 
044		-      :
		0,1 -   ,   0
		2 -  ,   012
		3 -  . 0  012 
		NORD 3.5 -      ,    - .
		   .
046		    : (  . )
		      , 
		  .  ,    -0011
		  ,      .
		        
		-0011,       .11  .11
0100	   ( 0)
0400	   ( 0123456)
0402	NORD 3.5:
		yepa ea  oooc pao ca  ccee MKDOS e
		op apya;
0466	NORD 3.5:
		oep ceopa oce oa ca, ..    .
		   32767,    .
0500	 .

   

 
---------------------------------------------
0		  :
		0 - 
		1 - ,  NORD 3.5   010,0100
		2 - 
		4 - NORD 3.5: ecaea aa
		0200-0377 -  
		   -  
1		 -  ,   
2		   .    = 0177,   
020		  
022		   
024		  
026		    (  0200000, ..    64,
		     )


   ,        .
     
   == 0377
  = 0377
   == 14  0377   3.5  "-?-?-?-?-?-?-?"   2.
  ==    
   == 0177777
 == 0177777
 == 0177777
,         .

!          .
      .


  .          .
,  , .   F:, G:  ..     .

*/
