#pragma once
#include "bkdimage.h"
#pragma pack(push)
#pragma pack(1)
struct RT11FileRecord {
	BYTE bUnk1;
	BYTE status;	//
	WORD name[2];	//   RADIX-50
	WORD ext;		//   RADIX-50
	WORD blk_size;	//   
	BYTE task_num;	// 
	BYTE chan_num;	// 
	WORD date;		//  
};
#pragma pack(pop)

#define RT11_FILESTATUS_TEMPORARY 1
#define RT11_FILESTATUS_UNUSED 2
#define RT11_FILESTATUS_CONSTANT 4
#define RT11_FILESTATUS_EOS 010
#define RT11_FILESTATUS_PROTECTED 0200

typedef struct {
	WORD segments_num;	// ,   
	WORD next_segment;	//   ,  0 -    
	WORD used_segments;	// ,  ,     
	WORD filerec_add;	//        
	WORD file_block;	// ,      ,    
} RT11SegmentHdr;



static const TCHAR RADIX50[050] = {
	//000..007
	_T(' '), _T('A'), _T('B'), _T('C'), _T('D'), _T('E'), _T('F'), _T('G'), 
	//010..017
	_T('H'), _T('I'), _T('J'), _T('K'), _T('L'), _T('M'), _T('N'), _T('O'), 
	//020..027
	_T('P'), _T('Q'), _T('R'), _T('S'), _T('T'), _T('U'), _T('V'), _T('W'), 
	//030..037
	_T('X'), _T('Y'), _T('Z'), _T('$'), _T('.'), _T(' '), _T('0'), _T('1'), 
	//040..047
	_T('2'), _T('3'), _T('4'), _T('5'), _T('6'), _T('7'), _T('8'), _T('9')
};


class CBKDRT11 :
	public CBKDImage
{
protected:
	CString DecodeRadix50(WORD *buf, int len);

public:
	CBKDRT11(CMyListCtrl* pLC, long nBaseOffset, CString strFileName);
	virtual ~CBKDRT11(void);

	virtual BOOL ReadCatalog();
	virtual CString GetInfo();
	virtual CString GetSpecificData(DWORD dd);

};

/*
0-  -  
	          000240. 
          
  .      ,  
           
.         . 
 RT-11       2-  5- . 
     ,  ,  ,    
        : 
BOOT NO VOLUME     .   2- 5-   
  .
	       ,
         .

1-  -  
	     :   ; 
 ,    ;     RADIX-50, 
  ;     , 
    ;  - 
   .

 	
----------------------------------
0		---		,   
0722	2		    ?
0724	2		  
0726	2		    RADIX-50
0730	12.		 
0744	12.		 
0760	12.		 

2-  -   
	 2-  5-    ,    
    .    
        
,    .    
1-4-   .

6-  -  ,   N*2+5,  N -    
     (  1..31,
  - 4),   - 2 .

	  .   512. , .. 2 .

 

.		
----------------------------------
0		2		 ,   .   
				   (   , 
				    )     
				  .
2		2		   .    
				     . 
				       .
4		2		 ,  .    
				     .   
				        .
6		2		        . 
				     .
010		2		 ,      ,
				   . ..      
				,    ,     
				  .
012		14.		  
....     ,  72.   .
	       ,     .
 ,       ,
     .       70 .
	    . ,     200 
  ,      3 .    
 .       2 ,
   ,        
.       .   
  DEC       
.      , .. 
      ,  .
    ,  ,     36 
  . 
	 ,      ,
       . ,  200
   ,   .  ,  
,  ,  ,   " ",
..          ,
       .


 
.		
----------------------------------
0		1		 0
1		1		
				001	0 	- 
				002	1		- 
				004	2		- 
				010	3		-   
				020	4
				040	5
				100	6
				200	7		- 
2		6		    RADIX-50, 2  - , 1  - 
010		2		  ( ?)
012		1		 
013		1		 
014		2		 xxxxxxxxxxxxxxxx
                       +--|+---|+---|- ,  0-4 (     1972,    )
                          |    ------- ,  5-9
                          ------------ ,  10-13

Radix-50

      :

A = 1600. * __ + 40. * __ + __


									
0		8	H		16	P		24	X		32	2
1	A		9	I		17	Q		25	Y		33	3
2	B		10	J		18	R		26	Z		34	4
3	C		11	K		19	S		27	$		35	5
4	D		12	L		20	T		28	.		36	6
5	E		13	M		21	U		29		37	7
6	F		14	N		22	V		30	0		38	8
7	G		15	O		23	W		31	1		39	9

  ,      ,
      .DSK

*/

